local NextPattern = nil
local patternIndex = 1
local msgIndex = 1

local function Schedule(delay)
	eapi.AddTimer(staticBody, delay, NextPattern)
end

local function AdvancePattern()
	patternIndex = patternIndex + 1
	bomb.ResetTime()
end

local function GetMessage()
	return state.cheater and "Cheater" or timing.messages[msgIndex]
end

local function CrunchPattern()
	timing.patternList[patternIndex]()
	if bomb.GetTime() > player.patternTime then
		AdvancePattern()
		ribbons.Flash(GetMessage())
		msgIndex = msgIndex + 1
	end	
end

local function Immediate(Function)
	return function()
		AdvancePattern()
		Schedule(0)
		Function()
	end
end

local function Delay(timeout)
	return function()
		AdvancePattern()
		Schedule(timeout)
		eapi.AddTimer(staticBody, timeout, bomb.ResetTime)
	end
end

NextPattern = CrunchPattern

local function IncHits()
	state.hits = state.hits + 1
end

timing = {
	Delay = Delay,
	Schedule = Schedule,
	Start = CrunchPattern,
	Immediate = Immediate,	
	IncHits = IncHits,
	patternList = { },
}
return timing
